SistemaERP/Controllers/NotaCompraController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Logica;
using Entidad;
using Datos;
using Entidad.Estados;
using Microsoft.Reporting.WebForms;

namespace SistemaERP.Controllers
{
    public class NotaCompraController : Controller
    {
        private LNotaCompra logica = LNotaCompra.Logica.LNotaCompra;
        public ActionResult Index()
        {

            try
            {
                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];

                return View(logica.listarNotaCompra(empresa.idEmpresa));
            }
            catch (Exception ex)
            {
                return JavaScript("MostrarMensaje('Ha ocurrido un error.');");
            }
        }

        public ActionResult NotaCompra()
        {

            try
            {
                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];

                Session["DetalleNotaCompra"] = new List<EDetalleNotaCompra>();
                ViewBag.Articulo = LArticulo.Logica.LArticulo.listarArticulo(empresa.idEmpresa);
                ViewBag.NroNota = logica.obtenerNroNotaCompra(empresa.idEmpresa);

                EDetalleNotaCompraVer d = new EDetalleNotaCompraVer();
                d.Ver = 0;
                Session["NotaCompraVer"] = d;

                EDetalleNotaCompraTotal e = new EDetalleNotaCompraTotal();
                e.Total = 0;
                

                Session["DetalleTotalCompra"] = e;

                return View();
            }
            catch (Exception ex)
            {
                return JavaScript("MostrarMensaje('Ha ocurrido un error.');");
            }
        }

        public ActionResult ListarDetalleNotaCompra()
        {

            List<EDetalleNotaCompra> detalle = new List<EDetalleNotaCompra>();
            EDetalleNotaCompraTotal total = new EDetalleNotaCompraTotal();

            try
            {


                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];


                detalle = Session["DetalleNotaCompra"] as List<EDetalleNotaCompra>;
                total = Session["DetalleTotalCompra"] as EDetalleNotaCompraTotal;



                return PartialView("ListaDetalleNotaCompra", detalle);

            }
            catch (MensageException ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }
            catch (Exception ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }

            // return PartialView("ListaDetalleComprobante", detalle);
        }

        public ActionResult RegistroDetalleNotaCompra(long idarticulo, int cantidad, double precio,string fechavencimiento)
        {

            try
            {

                if (!string.IsNullOrEmpty(fechavencimiento))
                {
                    DateTime FechaInicio = DateTime.Parse(fechavencimiento);
                }

             
           
            }
            catch (Exception ex)
            {
                throw new MensageException("Ingrese las fechas con formato valido");
            }

            List<EDetalleNotaCompra> detalle = new List<EDetalleNotaCompra>();
            EDetalleNotaCompraTotal total = new EDetalleNotaCompraTotal();

            try
            {


                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];


                detalle = Session["DetalleNotaCompra"] as List<EDetalleNotaCompra>;
                // total = Session["DetalleTotal"] as EDetalleTotal;

                var articulo = LArticulo.Logica.LArticulo.obtenerArticulo1(idarticulo,empresa.idEmpresa);

             /*   if (Int32.)
                {
                    throw new MensageException("Debe ingresar un valor");
                }*/

                if (Double.IsNaN(precio))
                {
                    throw new MensageException("Debe ingresar un precio");
                }



                if (detalle.Count == 0)
                {
                    EDetalleNotaCompra d = new EDetalleNotaCompra();
                    d.IdArticulo = idarticulo;
                    d.NombreArticulo = articulo.Nombre;
                    d.Cantidad = cantidad;
                    d.Precio = precio;
                    d.SubTotal = Math.Round((d.Cantidad * d.Precio), 2) ;
                    if (!string.IsNullOrEmpty(fechavencimiento))
                    {
                       d.FechaVencimiento = DateTime.Parse(fechavencimiento);
                    }
                    detalle.Add(d);

                    total.Total = d.SubTotal;

                }
                else if (detalle.Count > 0)
                {

                    foreach (var i in detalle)
                    {
                        if (articulo.IdArticulo == i.IdArticulo)
                        {
                            throw new MensageException("El articulo ya existe en el listado");
                        }

                        total.Total = Math.Round((total.Total + i.SubTotal), 2);
                       

                    }

                    EDetalleNotaCompra d = new EDetalleNotaCompra();
                    d.IdArticulo = idarticulo;
                    d.NombreArticulo = articulo.Nombre;
                    d.Cantidad = cantidad;
                    d.Precio = precio;
                    d.SubTotal = Math.Round((d.Cantidad * d.Precio), 2) ;
                    if (!string.IsNullOrEmpty(fechavencimiento))
                    {
                        d.FechaVencimiento = DateTime.Parse(fechavencimiento);
                    }
                    detalle.Add(d);

                    total.Total = Math.Round((total.Total + d.SubTotal), 2);

                 
                }


            
              

                Session["DetalleNotaCompra"] = detalle;
                Session["DetalleTotalCompra"] = total;

                string hola = "hola";
                return JavaScript("MensajeExitoDetalle('" + hola + "');");
            }
            catch (MensageException ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }
            catch (Exception ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }

            // return PartialView("ListaDetalleComprobante", detalle);
        }

        public ActionResult EditarDetalleNotaCompra(long idarticulo, int cantidad, double precio, string fechavencimiento)
        {

            List<EDetalleNotaCompra> detalle = new List<EDetalleNotaCompra>();
            EDetalleNotaCompraTotal total = new EDetalleNotaCompraTotal();

            try
            {


                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];


                detalle = Session["DetalleNotaCompra"] as List<EDetalleNotaCompra>;
                // total = Session["DetalleTotal"] as EDetalleTotal;

                var articulo = LArticulo.Logica.LArticulo.obtenerArticulo1(idarticulo,empresa.idEmpresa);


                /*int cuentaRepetidas = 0;

                foreach (var i in detalle)
                {
                    if (i.IdArticulo == idarticulo)
                    {
                        cuentaRepetidas = cuentaRepetidas + 1;
                    }
                }

                if (cuentaRepetidas >= 2)
                {
                    throw new MensageException("El articulo ya existe en el listado");
                }*/


                foreach (var i in detalle)
                {
                    if (articulo.IdArticulo == i.IdArticulo)
                    {
                      
                        i.NombreArticulo = articulo.Nombre;
                        i.Cantidad = cantidad;
                        i.Precio = precio;
                        i.SubTotal = Math.Round((i.Cantidad * i.Precio), 2);
                        if (!string.IsNullOrEmpty(fechavencimiento))
                        {
                            i.FechaVencimiento = DateTime.Parse(fechavencimiento);
                        }
                        else
                        {
                            i.FechaVencimiento = null;
                        }
                    }

                    total.Total = Math.Round((total.Total + i.SubTotal), 2);


                }



                Session["DetalleNotaCompra"] = detalle;
                Session["DetalleTotalCompra"] = total;

                string hola = "editar exito";
                return JavaScript("MensajeExitoDetalle('" + hola + "');");
            }
            catch (MensageException ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }
            catch (Exception ex)
            {
                return JavaScript("MostrarMensaje('" + ex.Message + "');");
            }

            // return PartialView("ListaDetalleComprobante", detalle);
        }

        [HttpPost]
        public ActionResult EliminarDetalleNotaCompra(long idarticulo)
        {


            try
            {


                Usuario usuario = (Usuario)Session["Usuario"];
                Empresa empresa = (Empresa)Session["Empresa"];

                List<EDetalleNotaCompra> detalleComprobantes = Session["DetalleNotaCompra"] as List<EDetalleNotaCompra>;
                detalleComprobantes.RemoveAll(p => p.IdArticulo == idarticulo);
                EDetalleNotaCompraTotal total = new EDetalleNotaCompraTotal();
                total.Total = 0;
               
                foreach (var i in detalleComprobantes)
                {

SistemaERP/Views/NotaCompra/ListaDetalleNotaCompra.cshtml
@using Datos;
@using Entidad.Estados;
@using Entidad;
@model List<EDetalleNotaCompra>
@{

    EDetalleNotaCompraTotal detalleTotal = Session["DetalleTotalCompra"] as EDetalleNotaCompraTotal;
    EDetalleNotaCompraVer detalleEstado = Session["NotaCompraVer"] as EDetalleNotaCompraVer;
}


<div style="height:200px; overflow: scroll;">
    <table class="table table-bordered table-hover" id="tabla_detalleComprobante">

        <thead>
            <tr>
                <th>ARTICULO</th>
                <th>CANTIDAD</th>
                <th>PRECIO</th>
                <th>SUBTOTAL</th>
                <th></th>
                <th></th>
            </tr>
        </thead>
        <tbody>

            @{
                foreach (var i in Model)
                {
                    <tr>

                        <td>@i.NombreArticulo</td>
                        <td>@i.Cantidad</td>

                        <td style="text-align:right;">@i.Precio</td>
                        <td style="text-align:right;">@i.SubTotal</td>
                        <td>
                            @{
                                if (detalleEstado.Ver == 0)
                                {
                                    <button class="btn btn-secondary form-group fas fa-edit" onclick="AbrirModalEditar('@i.IdArticulo', '@i.NombreArticulo', '@(i.FechaVencimiento!= null? i.FechaVencimiento.Value.ToString("dd/MM/yyy"): "" )', '@i.Cantidad', '@i.Precio')"> </button>
                                }
                            }

                        </td>
                        <td>
                            @{
                                if (detalleEstado.Ver == 0)
                                {
                                    <button class="btn btn-danger form-group  fas fa-trash-alt" onclick="AbrirModalEliminar('@i.IdArticulo', '@i.NombreArticulo')"> </button>
                                }
                            }

                        </td>
                    </tr>

                }


            }

        </tbody>

    </table>
</div>
    <br />
    <div class="row justify-content-end">
        <div class="col-md-2">
            <div class="form-group">
                <label>TOTALES:</label>
            </div>
        </div>

        @{

            if (detalleTotal != null)
            {

                <div class="col-md-2">
                    <div class="form-group">

                        <input type="number" class="form-control" id="itTotalHaber" value="@detalleTotal.Total" style="text-align:right;" disabled>
                    </div>
                </div>
                <div class="col-md-2">
                    <div class="form-group">


                    </div>
                </div>
            }
            else
            {

                <div class="col-md-2">
                    <div class="form-group">

                        <input type="number" class="form-control" id="itTotalHaber" style="text-align:right;" disabled>
                    </div>
                </div>
                <div class="col-md-2">
                    <div class="form-group">


                    </div>
                </div>
            }

        }



    </div>

SistemaERP/Views/NotaCompra/ListaNotaCompra.cshtml
@using Datos;
@using Entidad.Estados;
@model List<Nota>



<table class="table table-bordered table-hover" id="tabla_gestion">

    <thead>
        <tr>
            <th>NRO NOTA</th>
            <th>FECHA</th>
            <th>DESCRIPCION</th>
            <th>ESTADO</th>
            <th></th>
        </tr>
    </thead>
    <tbody>

        @{
            foreach (var i in Model)
            {
                <tr>

                    <td>@i.NroNota</td>
                    <td>@i.Fecha.ToString("dd/MM/yyyy")</td>
                    <td>@i.Descripcion</td>
                    @{ 

                        if(i.Estado == (int)EstadoNota.Activo)
                        {


                             <td>Activo</td>
                        }
                        else
                        {
                            <td>Anulado</td>
                        }

                    }
                    <td>

                        <a href="@Url.Action("ENotaCompra", "NotaCompra", new { idnota = i.IdNota })" class="btn btn-secondary "><i class="fas fa-eye"></i> </a>
                    </td>
                </tr>
            }
        }

    </tbody>

</table>

SistemaERP/Views/NotaCompra/ReporteNotaCompra.cshtml
@using ReportViewerForMvc;
@using Datos;
@using Entidad;

@{
    ViewBag.Title = "Reporte Nota Compra";
   // Gestion gestion = ESesion.ObtenerGestion<Gestion>(Session["Gestion"]);
    Layout = "~/Views/Shared/_Layout.cshtml";

    List<ENota> notas = ViewBag.NotaCompra;
}
@section EtiquetaHead
    {



    <link href="@Url.Content("~/Content/adminLte/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css")" rel="stylesheet" />
    <link href="@Url.Content("~/Content/adminLte/plugins/datatables-responsive/css/responsive.bootstrap4.min.css")" rel="stylesheet" />


    <link href="@Url.Content("~/Content/bootstrap-datepicker/css/bootstrap-datepicker.css")" rel="stylesheet" />
    <link href="@Url.Content("~/Content/bootstrap-datepicker/css/bootstrap-datepicker3.css")" rel="stylesheet" />

    @* pdf <link href="//cdn.datatables.net/buttons/1.5.6/css/buttons.bootstrap4.min.css" rel="stylesheet">
    *@

    @*<link href="@Url.Content("~/Content/adminLte/plugins1/datatables/datatables.min.css")" rel="stylesheet" />
        <link href="@Url.Content("~/Content/adminLte/plugins1/datatables/plugins/bootstrap/datatables.bootstrap.css")" rel="stylesheet" />
    *@
}



<section class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">



        </div>
    </div><!-- /.container-fluid -->
</section>

<section class="content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <!-- Default box -->
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title">
                          Reporte Nota Compra
                        </h3>

                    </div>
                    <div class="card-body">


                        <div class="row ">
                            <div class="form-group">
                                <a href="@Url.Action("ENotaCompra", "NotaCompra", new { idnota = notas.FirstOrDefault().IdNota })" class="btn btn-secondary" style="margin-left:10px;"> <i class=" fas fa-undo-alt"></i>  </a>
                            </div>


                        </div>
                        <div class="form-group"  style="width: 900px; height: 900px;">
                            @Html.ReportViewer(ViewBag.ReporteNotaCompra as Microsoft.Reporting.WebForms.ReportViewer, new { style = "width: 900px; height:900px " })

                        </div>




                    </div>
                    <!-- /.card-body -->
                    <div class="card-footer">

                    </div>
                    <!-- /.card-footer-->
                </div>
                <!-- /.card -->
            </div>
        </div>
    </div>
</section>


@section Scripts{


    <script src="@Url.Content("~/Content/adminLte/plugins/datatables/jquery.dataTables.min.js")"></script>

    <script src="@Url.Content("~/Content/adminLte/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/Content/adminLte/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/Content/adminLte/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>

    <script src="@Url.Content("~/Content/bootstrap-datepicker/js/bootstrap-datepicker.min.js")"></script>

    @* Buttons pdf <script src="//cdn.datatables.net/buttons/1.5.6/js/dataTables.buttons.min.js"></script>
        <script src="//cdn.datatables.net/buttons/1.5.6/js/buttons.bootstrap4.min.js"></script>
        <script src="//cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
        <script src="//cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.53/pdfmake.min.js"></script>
        <script src="//cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.53/vfs_fonts.js"></script>
        <script src="//cdn.datatables.net/buttons/1.5.6/js/buttons.html5.min.js"></script>
        <script src="//cdn.datatables.net/buttons/1.5.6/js/buttons.print.min.js"></script>
        <script src="//cdn.datatables.net/buttons/1.5.6/js/buttons.colVis.min.js"></script>*@


    @*<script src="@Url.Content("~/Scripts/metronic/global/scripts/datatable.js")"></script>

        <script src="@Url.Content("~/Content/adminLte/plugins1/datatables/datatables.min.js")"></script>
        <script src="@Url.Content("~/Content/adminLte/plugins1/datatables/plugins/bootstrap/datatables.bootstrap.js")"></script>
    *@
    <script type="text/javascript">




        $(document).ready(function () {
          

        });

        function redireccionar(url) {
            window.location = url;
        }







         
        

        function MostrarMensaje(msj) {
                $("#modalEliminar").modal('hide');


                 $(document).Toasts('create', {
                        class: ' bg-danger',
                        title: "Alerta",
                        autohide: true,
                        delay: 10000,
                        body: msj
                    });
        }


         


       
      




    </script>

}